import java.util.Arrays;

public class Einstufungstest {

    //Implementieren Sie hier die in der Angabe beschriebenen statischen Methoden.


    public static int[][] generate(int[] inputArray) {
        int num_lines = inputArray.length + 1;
        int[][] output = new int[num_lines][];

        output[0] = inputArray;

        int num_entries = inputArray.length;
        for(int i=1; i<num_lines; i++) {
            output[i] = new int[num_entries];
            for(int j=0; j<num_entries; j++) {
                output[i][j] = inputArray[j];
            }
            num_entries--;
        }

        return output;
    }


    public static void change(int[][] inputArray) {
        // first, create a deep copy of inputArray
        int[][] copied = new int[inputArray.length][];
        for(int i=0; i<inputArray.length; i++) {
            copied[i] = new int[inputArray[i].length];
            for(int j=0; j<inputArray[i].length; j++) {
                copied[i][j] = inputArray[i][j];
            }
        }

        // then make inputArray a square array with 0s
        int num_lines = inputArray.length;
        for(int i=0; i<num_lines; i++) {
            inputArray[i] = new int[num_lines];
            for(int j=0; j<num_lines; j++) {
                inputArray[i][j] = 0;
            }
        }

        // now insert values from original array (copied)
        int column = num_lines-1;
        for(int i=0; i<copied.length; i++) { // for each line of copied
            for(int j=0; j<copied[i].length; j++) { // for each entry of copied[i]
                if(j >= num_lines) break; // break if it exceeds bounds
                inputArray[j][column] = copied[i][j];
            }
            column--;
        }
    }


    public static boolean isEqual(String s1, String s2) {
        if(s1 == null && s2 == null) return true;
        if(s1 == null || s2 == null) return false;
        if(s1.isEmpty() && s2.isEmpty()) return true;
        if(s1.isEmpty() || s2.isEmpty()) return false;
        char c1 = s1.charAt(0);
        char c2 = s2.charAt(0);
        if(c1 == c2) return isEqual(s1.substring(1), s2.substring(1));
        else return false;
    }


    public static void main(String[] args) {

        //Implementieren Sie hier die in der Angabe beschriebenen Aufgaben für "main".

        int[] test1 = {1, -5, 0, 6};
        int[][] test2 = {{1},{2},{3}};
        int[][] test3 = {{1, 0, 1}, {}, {5, 5, 6, 5}, {}};
        int[][] test4 = {{7, 7, 5, 7, 3}, {2, -4}, {10, 20, 30}, {-1, -2, -3, -4, -5, -6, -7}};
        int[][] test5 = {{}, {}}, test6 = {{}};


        int[][] result1;
        result1 = generate(test1);
        System.out.println(Arrays.deepToString(result1));
        System.out.println(result1[0] == test1);
        System.out.println(result1[0] == result1[1]);
        System.out.println(result1[0] == result1[2]);
        System.out.println(result1[1] == result1[2]);


        System.out.println("");


        change(test2);
        System.out.println(Arrays.deepToString((test2)));
        change(test3);
        System.out.println(Arrays.deepToString((test3)));
        change(test4);
        System.out.println(Arrays.deepToString((test4)));
        change(test5);
        System.out.println(Arrays.deepToString((test5)));
        change(test6);
        System.out.println(Arrays.deepToString((test6)));


        System.out.println("");


        System.out.println(isEqual("blah", "blahblah"));
        System.out.println(isEqual("blah", "blah"));
        System.out.println(isEqual("", ""));
        System.out.println(isEqual(null, null));
    }
}
